Loading...
Searching...
No Matches
irr::scene::IColladaMeshWriterNames Class Referenceabstract

Callback interface to use custom names on collada writing. More...

`#include <IColladaMeshWriter.h>`

Inheritance diagram for irr::scene::IColladaMeshWriterNames:

## Public Member Functions

virtual | ~IColladaMeshWriterNames ()
virtual irr::core::stringw | nameForMaterial (const video::SMaterial &material, int materialId, const scene::IMesh *mesh, const scene::ISceneNode *node)=0
| Return a name for the material.
virtual irr::core::stringw | nameForMesh (const scene::IMesh *mesh, int instance)=0
| Return a unique name for the given mesh.
virtual irr::core::stringw | nameForNode (const scene::ISceneNode *node)=0
| Return a unique name for the given node.
Public Member Functions inherited from irr::IReferenceCounted
| IReferenceCounted ()
| Constructor.
virtual | ~IReferenceCounted ()
| Destructor.
bool | drop () const
| Drops the object. Decrements the reference counter by one.
const c8 * | getDebugName () const
| Returns the debug name of the object.
s32 | getReferenceCount () const
| Get the reference count.
void | grab () const
| Grabs the object. Increments the reference counter by one.

## Additional Inherited Members

Protected Member Functions inherited from irr::IReferenceCounted
void | setDebugName (const c8 *newName)
| Sets the debug name of the object.

## Detailed Description

Callback interface to use custom names on collada writing.

You can either modify names and id's written to collada or you can use this interface to just find out which names are used on writing.

Definition at line 158 of file IColladaMeshWriter.h.

## Constructor & Destructor Documentation

## ~IColladaMeshWriterNames()

virtual irr::scene::IColladaMeshWriterNames::~IColladaMeshWriterNames | ( |  | ) |

inline virtual

Definition at line 162 of file IColladaMeshWriter.h.

## Member Function Documentation

## nameForMaterial()

virtual irr::core::stringw irr::scene::IColladaMeshWriterNames::nameForMaterial | ( | const video::SMaterial & | material,
|  | int | materialId,
|  | const scene::IMesh * | mesh,
|  | const scene::ISceneNode * | node )

pure virtual

Return a name for the material.

There is one material created in the writer for each unique name. So you can use this to control the number of materials which get written. For example Irrlicht does by default write one material for each material instanced by a node. So if you know that in your application material instances per node are identical between different nodes you can reduce the number of exported materials using that knowledge by using identical names for such shared materials. Names must follow the xs::NCName standard to be valid, you can run them through IColladaMeshWriter::toNCName to ensure that.

## nameForMesh()

virtual irr::core::stringw irr::scene::IColladaMeshWriterNames::nameForMesh | ( | const scene::IMesh * | mesh,
|  | int | instance )

pure virtual

Return a unique name for the given mesh.

Note that names really must be unique here per mesh-pointer, so mostly it's a good idea to return the nameForMesh from IColladaMeshWriter::getDefaultNameGenerator(). Also names must follow the xs::NCName standard to be valid, you can run them through IColladaMeshWriter::toNCName to ensure that.

Parameters

  mesh | Pointer to the mesh which needs a name
  instance | When E_COLLADA_GEOMETRY_WRITING is not ECGI_PER_MESH then several instances of the same mesh can be written and this counts them.

## nameForNode()

virtual irr::core::stringw irr::scene::IColladaMeshWriterNames::nameForNode | ( | const scene::ISceneNode * | node | ) |

pure virtual

Return a unique name for the given node.

Note that names really must be unique here per node-pointer, so mostly it's a good idea to return the nameForNode from IColladaMeshWriter::getDefaultNameGenerator(). Also names must follow the xs::NCName standard to be valid, you can run them through IColladaMeshWriter::toNCName to ensure that.

The documentation for this class was generated from the following file:

- IColladaMeshWriter.h

- Irrlicht Engine Documentation © 2003-2012 by Nikolaus Gebhardt. Generated on for Irrlicht 3D Engine by Doxygen 1.15.0